#ifndef KOMPLEX_H
#define KOMPLEX_H

#include <iostream>
#include <cmath>
using namespace std;
template <class T>
class komplex
{
    public:
        /**  Default constructor */
        komplex():_real(0.0),_imag(0.0) {};
        /** Parameter constructor */
        komplex(T real, T imag=0.0);
        /** Default destructor */
        ~komplex();
        /** Access _real
         * \return The current value of _real
         */
        T Get_real() const { return _real; }
        /** Set _real
         * \param val New value to set
         */
        void Set_real(T val) { _real = val; }
        /** Access _imag
         * \return The current value of _imag
         */
        T Get_imag() const { return _imag; }
        /** Set _imag
         * \param val New value to set
         */
        void Set_imag(T val) { _imag = val; }

        T abs() const
        { return sqrt(_real*_real+_imag*_imag);};

        komplex<T>& operator+=(const komplex<T> rhs);
        komplex<T>  operator+(const komplex<T> rhs) const;

        bool operator<(const komplex<T> rhs) const
           { return _real < rhs._real;};

    protected:
    private:
        T _real; //!< Member variable "_real"
        T _imag; //!< Member variable "_imag"
};

template <class T>
ostream& operator<<(ostream& s, const komplex<T>& rhs);

#include "komplex.cpp"
#endif // KOMPLEX_H
