#include <iostream>
#include <vector>
#include <algorithm>
#include "komplex.h"
using namespace std;

template <class T>
T square(T x)
{
    T tmp=x*x;
    cout << "size of T " << sizeof(tmp) << endl;
    return tmp;
}

template <class T>
bool larger_abs(const komplex<T>& a,const komplex<T>& b)
{
    return a.abs() > b.abs();
}

int main()
{
    cout << "Hello world!" << endl;

    const komplex<float> a(3,-7.2);
    cout << a.Get_real() << "," << a.Get_imag() << endl;
    komplex<float> c(a);  // Copy-Constructor is used

    c += a;  // c.operator+=(a)

    komplex<float> b(1.0);
    b = a+c;  // b.operator=( a+c )
              // b.operator=( a.operator+(c) )

    cout << b << endl;

    vector<komplex<float> > vv(2);
    vv[0] = komplex<float>(3,-2.1);
    vv.at(1) = b;
    vv.push_back(c);
    vv.push_back(komplex<float>(-2));

    cout << "Size of vv: " << vv.size() << endl;
    for (unsigned int i=0; i<vv.size();++i)
    {
        cout << vv[i] << "  ";
    }
    cout << endl;

    //vv.pop_back();
    //cout << "Size of vv: " << vv.size() << endl;

    sort(vv.begin(),vv.end());  // komplex:operator<
    sort(vv.begin(),vv.end(),larger_abs<float>);  // use function larger_abs


    cout << "Size of vv: " << vv.size() << endl;
    for (unsigned int i=0; i<vv.size();++i)
    {
        cout << vv[i] << "  ";
    }
    cout << endl;

     cout << square(2) << endl;
     cout << square(2.5) << endl;
    return 0;
}
